using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

namespace Azbest
{
    public class Tile : IDrawableSquare
    {
        public int [] SideColors = new int [4];       

        public int LeftColor
        {
            get { return SideColors[0]; }
        }

        public int TopColor
        {
            get { return SideColors[1]; }
        }

        public int RightColor
        {
            get { return SideColors[2]; }
        }

        public int BottomColor
        {
            get { return SideColors[3]; }
        }

        public Tile(int leftColor, int topColor, int rightColor, int bottomColor)
        {
            SideColors[0] = leftColor;
            SideColors[1] = topColor;
            SideColors[2] = rightColor;
            SideColors[3] = bottomColor;
        }

        public Tile(Tile otherTile)
        {
            SideColors[0] = otherTile.SideColors[0];
            SideColors[1] = otherTile.SideColors[1];
            SideColors[2] = otherTile.SideColors[2];
            SideColors[3] = otherTile.SideColors[3];
        }

        public void RotateForGood(uint rotation)
        {
            int [] oldSides = (int [])SideColors.Clone();

            for (int i = 0; i < 4; ++i)
            {
                SideColors[i] = oldSides[(i + 4 - rotation) % 4];
            }            
        }

        public string GetSidesString()
        {
            return SideColors[0].ToString() + " " + SideColors[1].ToString() + " " + SideColors[2].ToString() + " " + SideColors[3].ToString() + " ";
        }
    }
}
