using System;
using System.Collections.Generic;
using System.Text;

namespace Azbest
{
    public struct BoardSocket : IEquatable <BoardSocket>
    {
        public int X;
        public int Y;

        public BoardSocket(int xPos, int yPos)
        {
            X = xPos;
            Y = yPos;
        }

        public float DistFromCenter()
        {
            float middle = (float)GameManager.Instance.BoardSize * 0.5f;
            return Math.Abs(middle - (float)X + 1.0f) * Math.Abs(middle - (float)X + 1.0f)
                + Math.Abs(middle - (float)Y + 1.0f) * Math.Abs(middle - (float)Y + 1.0f);
        }

        public bool IsNeighbour(ref BoardSocket second)
        {
            return ((Math.Abs(X - second.X) + Math.Abs(Y - second.Y)) == 1);
        }

        #region IEquatable<BoardSocket> Members

        public bool Equals(BoardSocket other)
        {
            return (X == other.X && Y == other.Y);
        }

        #endregion
    }

    public class BoardSocketCenterDistSorter : IComparer<BoardSocket>
    {
        public int Compare(BoardSocket x, BoardSocket y)
        {
            if (x.DistFromCenter() < y.DistFromCenter())
            {
                return -1;
            }
            else
            {
                if (x.DistFromCenter() > y.DistFromCenter())
                {
                    return 1;
                }
                if (x.X < y.X) return -1;
                if (x.X > y.X) return 1;
                if (x.Y < y.Y) return -1;
                if (x.Y > y.Y) return 1;
                return 0;
            }
        }        
    }
}
